﻿Imports System.IO
Imports System.Text

Public Class Form1
    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles Me.Load
        Dim textBuilder As New StringBuilder()

        Using stream As FileStream = File.Open("c:\ds_store\samples\temp\ds_store", FileMode.Open)
            Using reader As New BinaryReader(stream, Encoding.UTF8, False)
                Dim bytearray() As Byte = reader.ReadBytes(4)
                Dim magic1 As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                If magic1 <> 1 Then
                    ActiveControl = StatusStrip1
                    TextBox1.Text = "Magic1 <> 1"
                    Exit Sub
                End If
                bytearray = reader.ReadBytes(4)
                Dim magic2 As String = Encoding.ASCII.GetString(bytearray)
                If magic2 <> "Bud1" Then
                    ActiveControl = StatusStrip1
                    TextBox1.Text = "Magic2 <> Bud1"
                    Exit Sub
                End If
                bytearray = reader.ReadBytes(4)
                Dim offset1 As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                bytearray = reader.ReadBytes(4)
                Dim size As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                bytearray = reader.ReadBytes(4)
                Dim offset2 As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                reader.BaseStream.Seek(offset1 + 4, 0)
                bytearray = reader.ReadBytes(4)
                Dim numberOffsets As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                reader.BaseStream.ReadByte()
                reader.BaseStream.ReadByte()
                reader.BaseStream.ReadByte()
                reader.BaseStream.ReadByte()
                Dim listOffset(numberOffsets) As UInteger
                For i As Integer = 1 To numberOffsets
                    bytearray = reader.ReadBytes(4)
                    listOffset(i) = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                Next
                For i As Integer = 1 To (256 - numberOffsets) * 4
                    reader.BaseStream.ReadByte()
                Next
                bytearray = reader.ReadBytes(4)
                Dim countTOC As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                Dim listTOCnames(countTOC) As String
                Dim listTOCcount(countTOC) As String
                For i As Integer = 1 To countTOC
                    Dim lengthName As UInteger = reader.ReadByte
                    bytearray = reader.ReadBytes(lengthName)
                    listTOCnames(i) = Encoding.ASCII.GetString(bytearray)
                    bytearray = reader.ReadBytes(4)
                    listTOCcount(i) = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                Next
                Dim index As UInteger = listOffset(listTOCcount(1) + 1)
                Dim offset As UInteger = index >> 5 << 5
                Dim size2 As UInteger = (1 << index + &H1F) * 2
                reader.BaseStream.Position = offset + 4
                bytearray = reader.ReadBytes(4)
                Dim blockID As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                bytearray = reader.ReadBytes(4)
                Dim internalBlocks As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                bytearray = reader.ReadBytes(4)
                Dim treeRecords As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                bytearray = reader.ReadBytes(4)
                Dim treeBlocks As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                Dim index2 As UInteger = listOffset(blockID + 1)
                Dim offset3 As UInteger = index2 >> 5 << 5
                Dim size3 As UInteger = (1 << index2 + &H1F) * 2
                reader.BaseStream.Position = offset3 + 4  '?
                bytearray = reader.ReadBytes(4)
                Dim blockMode As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                bytearray = reader.ReadBytes(4)
                Dim recordCount As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                If blockMode <> 0 Then
                    TextBox1.Text = "blockMode <> 0"
                    Exit Sub
                End If
                For i As Integer = 1 To recordCount
                    bytearray = reader.ReadBytes(4)
                    Dim recordLength As UInteger = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                    Dim recordName As String = ""
                    For j As Integer = 1 To recordLength
                        reader.ReadByte()
                        recordName = recordName + Chr(reader.ReadByte)
                    Next
                    textBuilder.AppendLine(recordName)
                    bytearray = reader.ReadBytes(4)
                    Dim strucctureID As String = Encoding.ASCII.GetString(bytearray)
                    bytearray = reader.ReadBytes(4)
                    Dim structureType As String = Encoding.ASCII.GetString(bytearray)
                    Dim skipBytes As UInteger
                    If structureType = "blob" Then
                        bytearray = reader.ReadBytes(4)
                        skipBytes = BitConverter.ToInt32(bytearray.Reverse.ToArray, 0)
                    ElseIf structureType = "bool" Then
                        bytearray = reader.ReadBytes(1)
                    ElseIf i < recordCount Then
                        TextBox1.Text = "Structure Type: '" + structureType + "':   not found!"
                        ActiveControl = StatusStrip1
                        Exit Sub
                    End If
                    For j As Integer = 1 To skipBytes
                        reader.ReadByte()
                    Next
                Next
            End Using
        End Using
        ActiveControl = StatusStrip1
        TextBox1.Text = textBuilder.ToString
    End Sub

End Class
